#include <stdio.h>
#include <pthread.h>
#include <unistd.h>

#define NUMBER_OF_THREADS 10
 
#define F_BEGIN 0
#define F_END 1


void print_integer(int);

pthread_mutex_t counter_mutex =  PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t flag_mutex =  PTHREAD_MUTEX_INITIALIZER;
int counter;
int flag;

void print_thread(void* vptr){
	int last = 0;
	pthread_detach(pthread_self());

        pthread_mutex_lock(&counter_mutex);
        printf("Thread");
	print_integer(++counter);
	if (counter == NUMBER_OF_THREADS) last = 1;	
        printf(": Hello, World!\n");
        pthread_mutex_unlock(&counter_mutex);

        pthread_mutex_lock(&flag_mutex);
	if (last == 1) flag = F_END;
        pthread_mutex_unlock(&flag_mutex);
}

int main(){
	pthread_t tid[NUMBER_OF_THREADS];
	int n;

	counter = 0;
	flag = F_BEGIN;

	for (n = 0; n < NUMBER_OF_THREADS; ++n){
		pthread_create(&tid[n], NULL, (void*) print_thread, NULL);
	}
	printf("Main Thread: Hello, World!\n");
	for(;;){
        pthread_mutex_lock(&flag_mutex);
	if (flag == F_END) break;
        pthread_mutex_unlock(&flag_mutex);
	}	
	return 0;
}
